<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for HealthCareProvider StructType
 * @subpackage Structs
 */
class HealthCareProvider extends AbstractStructBase
{
    /**
     * The HCPName
     * @var string
     */
    public $HCPName;
    /**
     * The HCPContactNr
     * @var string
     */
    public $HCPContactNr;
    /**
     * The HCPYears
     * @var string
     */
    public $HCPYears;
    /**
     * The HCPOtherConsult
     * @var string
     */
    public $HCPOtherConsult;
    /**
     * The HCPDibConsult
     * @var string
     */
    public $HCPDibConsult;
    /**
     * The HCPCellNr
     * @var string
     */
    public $HCPCellNr;
    /**
     * The HCPEmail
     * @var string
     */
    public $HCPEmail;
    /**
     * Constructor method for HealthCareProvider
     * @uses HealthCareProvider::setHCPName()
     * @uses HealthCareProvider::setHCPContactNr()
     * @uses HealthCareProvider::setHCPYears()
     * @uses HealthCareProvider::setHCPOtherConsult()
     * @uses HealthCareProvider::setHCPDibConsult()
     * @uses HealthCareProvider::setHCPCellNr()
     * @uses HealthCareProvider::setHCPEmail()
     * @param string $hCPName
     * @param string $hCPContactNr
     * @param string $hCPYears
     * @param string $hCPOtherConsult
     * @param string $hCPDibConsult
     * @param string $hCPCellNr
     * @param string $hCPEmail
     */
    public function __construct($hCPName = null, $hCPContactNr = null, $hCPYears = null, $hCPOtherConsult = null, $hCPDibConsult = null, $hCPCellNr = null, $hCPEmail = null)
    {
        $this
            ->setHCPName($hCPName)
            ->setHCPContactNr($hCPContactNr)
            ->setHCPYears($hCPYears)
            ->setHCPOtherConsult($hCPOtherConsult)
            ->setHCPDibConsult($hCPDibConsult)
            ->setHCPCellNr($hCPCellNr)
            ->setHCPEmail($hCPEmail);
    }
    /**
     * Get HCPName value
     * @return string|null
     */
    public function getHCPName()
    {
        return $this->HCPName;
    }
    /**
     * Set HCPName value
     * @param string $hCPName
     * @return \StructType\HealthCareProvider
     */
    public function setHCPName($hCPName = null)
    {
        // validation for constraint: string
        if (!is_null($hCPName) && !is_string($hCPName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($hCPName, true), gettype($hCPName)), __LINE__);
        }
        $this->HCPName = $hCPName;
        return $this;
    }
    /**
     * Get HCPContactNr value
     * @return string|null
     */
    public function getHCPContactNr()
    {
        return $this->HCPContactNr;
    }
    /**
     * Set HCPContactNr value
     * @param string $hCPContactNr
     * @return \StructType\HealthCareProvider
     */
    public function setHCPContactNr($hCPContactNr = null)
    {
        // validation for constraint: string
        if (!is_null($hCPContactNr) && !is_string($hCPContactNr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($hCPContactNr, true), gettype($hCPContactNr)), __LINE__);
        }
        $this->HCPContactNr = $hCPContactNr;
        return $this;
    }
    /**
     * Get HCPYears value
     * @return string|null
     */
    public function getHCPYears()
    {
        return $this->HCPYears;
    }
    /**
     * Set HCPYears value
     * @param string $hCPYears
     * @return \StructType\HealthCareProvider
     */
    public function setHCPYears($hCPYears = null)
    {
        // validation for constraint: string
        if (!is_null($hCPYears) && !is_string($hCPYears)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($hCPYears, true), gettype($hCPYears)), __LINE__);
        }
        $this->HCPYears = $hCPYears;
        return $this;
    }
    /**
     * Get HCPOtherConsult value
     * @return string|null
     */
    public function getHCPOtherConsult()
    {
        return $this->HCPOtherConsult;
    }
    /**
     * Set HCPOtherConsult value
     * @param string $hCPOtherConsult
     * @return \StructType\HealthCareProvider
     */
    public function setHCPOtherConsult($hCPOtherConsult = null)
    {
        // validation for constraint: string
        if (!is_null($hCPOtherConsult) && !is_string($hCPOtherConsult)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($hCPOtherConsult, true), gettype($hCPOtherConsult)), __LINE__);
        }
        $this->HCPOtherConsult = $hCPOtherConsult;
        return $this;
    }
    /**
     * Get HCPDibConsult value
     * @return string|null
     */
    public function getHCPDibConsult()
    {
        return $this->HCPDibConsult;
    }
    /**
     * Set HCPDibConsult value
     * @param string $hCPDibConsult
     * @return \StructType\HealthCareProvider
     */
    public function setHCPDibConsult($hCPDibConsult = null)
    {
        // validation for constraint: string
        if (!is_null($hCPDibConsult) && !is_string($hCPDibConsult)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($hCPDibConsult, true), gettype($hCPDibConsult)), __LINE__);
        }
        $this->HCPDibConsult = $hCPDibConsult;
        return $this;
    }
    /**
     * Get HCPCellNr value
     * @return string|null
     */
    public function getHCPCellNr()
    {
        return $this->HCPCellNr;
    }
    /**
     * Set HCPCellNr value
     * @param string $hCPCellNr
     * @return \StructType\HealthCareProvider
     */
    public function setHCPCellNr($hCPCellNr = null)
    {
        // validation for constraint: string
        if (!is_null($hCPCellNr) && !is_string($hCPCellNr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($hCPCellNr, true), gettype($hCPCellNr)), __LINE__);
        }
        $this->HCPCellNr = $hCPCellNr;
        return $this;
    }
    /**
     * Get HCPEmail value
     * @return string|null
     */
    public function getHCPEmail()
    {
        return $this->HCPEmail;
    }
    /**
     * Set HCPEmail value
     * @param string $hCPEmail
     * @return \StructType\HealthCareProvider
     */
    public function setHCPEmail($hCPEmail = null)
    {
        // validation for constraint: string
        if (!is_null($hCPEmail) && !is_string($hCPEmail)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($hCPEmail, true), gettype($hCPEmail)), __LINE__);
        }
        $this->HCPEmail = $hCPEmail;
        return $this;
    }
}
